
Name:           easyloggingpp
Version:        9.97.1
Release:    1%{?dist}
Summary:        C++ logging library

License:        MIT
URL:            https://github.com/abumq/easyloggingpp
Source0:         %{url}/archive/v%{version}/easyloggingpp-%{version}.tar.gz

Patch0:          %{url}/pull/817.patch
Patch1:          %{url}/pull/818.patch

%global debug_package %{nil}

BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  ninja-build

BuildRequires:  cmake(gtest)

BuildRequires:  hardlink
BuildRequires:  symlinks
BuildRequires:  dos2unix

%global common_description %{expand:
Easylogging++ is an efficient logging library for C++ applications. It is
extremely powerful, highly extendable and configurable to a user’s
requirements. It provides the ability to write your own sinks (via featured
referred as LogDispatchCallback). This library is currently used by hundreds of
open-source projects on github and other open-source source control management
sites.}

%description %{common_description}


%package        devel
Summary:        Development files for Easylogging++

BuildArch:      noarch

Provides:       easyloggingpp-static = %{version}-%{release}

%description    devel %{common_description}

The easyloggingpp-devel package contains libraries and header files for
developing applications that use Easylogging++.


%package        doc
Summary:        Documentation and examples for Easylogging++

BuildArch:      noarch
Requires:       easyloggingpp-devel = %{version}-%{release}

%description    doc %{common_description}

The easyloggingpp-doc package contains documentation and examples for
developing applications that use Easylogging++.


%prep
%autosetup -n easyloggingpp-%{version} -p1
find . -type f \( -name '.git*' -o -name '.travis*' \) -print -delete
find . -depth -type d -name '.vs' -print -execdir rm -rvf '{}' ';'
dos2unix samples/Qt/fast-dictionary/words.txt
find samples/VC++ -type f -execdir dos2unix '{}' '+'


%build
%cmake -GNinja -Dtest:BOOL=TRUE
%cmake_build


%install
%cmake_install

install -d '%{buildroot}%{_pkgdocdir}'
cp -rvp *.md doc samples '%{buildroot}%{_pkgdocdir}'
find '%{buildroot}%{_pkgdocdir}/samples' -type f \
    \( -name 'easylogging++.cc' -o -name 'easylogging++.h' \) |
  while read -r fn
  do
    ln -svf "%{buildroot}%{_includedir}/$(basename "${fn}")" "${fn}"
    symlinks -c -o "${fn}"
  done
hardlink '%{buildroot}%{_pkgdocdir}/samples'
(
  find samples/ -type d -printf '\045doc \045dir \045{_pkgdocdir}/%p\n'
  find samples/ -type f -name 'LICENCE' \
      -printf '\045license \045{_pkgdocdir}/%p\n'
  find samples/ -type f ! -name 'LICENCE' \
      -printf '\045doc \045{_pkgdocdir}/%p\n'
) | tee samples.files


%check
%{_vpath_builddir}/easyloggingpp-unit-tests \
    --gtest_filter=-CommandLineArgsTest.LoggingFlagsArg


%files devel
%license LICENSE
%{_includedir}/easylogging++.h
%{_includedir}/easylogging++.cc
%{_datadir}/pkgconfig/easyloggingpp.pc


%files doc -f samples.files
%license LICENSE
%dir %{_pkgdocdir}
%doc %{_pkgdocdir}/*.md
%doc %{_pkgdocdir}/doc/


%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 9.97.1-1
- initial build
